//author: Thomas Hohmann D-Schwaigern
Lektion=[];

ZuLoesendeVokabeln=[];
ZuLoesVokNeu=[];
var Vokabelspeicher={};
var AnzeigeRichtig=0;
var AnzeigeFalsch=0;
var Zwischenspeicher={
		Timer:0,
		Timerzeit:0,
		Timerstopp:0,
		Timeraktiv:0
		};

function $id(id){
	return document.getElementById(id);
}

function iso_Konvertierung(Eingabe){
	//utf-8 zu iso-8859-1
	Wert=Eingabe;
	utf=["Ä","ä","Ö","ö","Ü","ü","ß","€","'"];
	iso=["Ã„","Ã¤","Ã–","Ã¶","Ãœ","Ã¼","ÃŸ","â‚¬","â€˜"];
	 for(var utfi in iso){
		var code=new RegExp(iso[utfi],'g');	
		Wert=Wert.replace(code,utf[utfi]); 	
	}
	return Wert;
}

function Zufallsreihe(Max,Anfang){
	var Max=(Max)?Max:10;
	var Anfang=(Anfang)?Anfang:0;
	var Marker=[];
	var Gemisch=[];
	
	for (zri=0; zri<=Max; zri++){ Marker[zri]= 0;}
			//Maximum an Zufallszahlen erstellen
		for (zri=0; zri<Max ; zri++){
			//Ziehung wiederhohlen, falls Zahlmarker 1 ist.
			do{
			Zufall = Math.round(Math.random() * 1000) % Max+Anfang;					
			}
			while (Marker[Zufall] == 1);
			//Zahlmarker auf 1 setzten, wenn Zahl gezogen wurde.
			Marker[Zufall]= 1;	
			Gemisch[zri] = Zufall;
		}
	return Gemisch;
}



function VokabelArray(){
	var DeuEng=(document.getElementsByName("Spr1Spr2")[0].checked == true)?0:1;
	var Vokabeln=[];
	var z=0;
	for(var i=1;i<=10;i++){
		var LektionCheck=$id("Lektion"+i).checked;
		if(LektionCheck==true){
			if(DeuEng==0){
				for (j in Lektion[i]){
					//Array bilden, wenn Tilde im Text erscheint. Und ein Zufallselement einfuegen.
					if(j.search(/~/)!=-1){
						var JArray=j.split("~");
						var JZufall=Zufallsreihe(JArray.length);
						Vokabeln[z]=iso_Konvertierung(JArray[JZufall[0]])+"QqQqQ"+iso_Konvertierung(Lektion[i][j]);
						z++;
					}
					else{
						Vokabeln[z]=iso_Konvertierung(j)+"QqQqQ"+iso_Konvertierung(Lektion[i][j]);
						z++;
					}	
				}
			}
			if(DeuEng==1){
				for (j in Lektion[i]){
					//Array bilden, wenn Tilde im Text erscheint. Und ein Zufallselement einfuegen.
					if(Lektion[i][j].search(/~/)!=-1){
						var LektArray=Lektion[i][j].split("~");
						var LektZufall=Zufallsreihe(LektArray.length);
						Vokabeln[z]=iso_Konvertierung(LektArray[LektZufall[0]])+"QqQqQ"+iso_Konvertierung(j);
						z++;
					}
					else{
						Vokabeln[z]=iso_Konvertierung(Lektion[i][j])+"QqQqQ"+iso_Konvertierung(j);
						z++;
					}	
				}
			}
		}
	}		
	ZuLoesendeVokabeln=Vokabeln;
	return Vokabeln;
}


function VokListeAusgeben(){
	var Lektionenangabe=[];
	var z=0;
	for(var i=1;i<=10;i++){
		var LektionCheck=$id("Lektion"+i).checked;
		if(LektionCheck==true){
			Lektionenangabe[z]=i;
			z++;
		}
	}
	Lektionenangabe="Lektion: "+Lektionenangabe.join(", ")
	
	var Liste=VokabelArray();
	Liste.sort();
	var Ausgabe=[];
	for (i in Liste){
		var Eintrag=Liste[i].split("QqQqQ");
		Ausgabe[i]="<tr><td>"+Eintrag[0]+"</td><td>"+Eintrag[1]+"</td></tr>"
	}
	AusgabeListe="<table border='1' cellspacing='0' cellpadding='4' rules='rows' ><tr><td colspan='2'><h3>"+Lektionenangabe+"</h3></td></tr>"+Ausgabe.join("")+"</table>"
	
	FensterListe = window.open("", "", "width=300,height=300,left=1,top=1,menubar=yes,scrollbars=yes");
	FensterListe.document.write(AusgabeListe);
	FensterListe.document.getElementsByTagName('body')[0].style.fontFamily="arial";
	FensterListe.document.title="Vokabelliste";
	window.setTimeout("FensterListe.stop()",3000);
}

function Vokabelausgabe(Vokabeln){
	Zwischenspeicher.Timer=0;
	Zwischenspeicher.Timerstopp=0;
	delete Vokabelspeicher;
	Vokabelspeicher={};
	Vokabeln=(typeof(Vokabeln)!="undefined")?Vokabeln:0;
	if(Vokabeln==0){
		var Vokabeln=VokabelArray();
		AnzeigeRichtig=0;
		AnzeigeFalsch=0;
	}
	else{
		var Vokabeln=ZuLoesendeVokabeln;
	}
	var VokAnzahl=$id("VokAnzahl").value;
	var Zufallszahlen=Zufallsreihe(Vokabeln.length);
	var Vokabelausgabe=[];
	if(VokAnzahl<=Vokabeln.length){
		for(i=0;i<VokAnzahl;i++){
			var Vokabelpaar=Vokabeln[Zufallszahlen[i]].split("QqQqQ");
			Vokabelausgabe[i]="<tr><td class='Vokabelvorgabe' id='VokVorgabe"+i+"' onclick='VokabelHilfe(this.id)'><span style='cursor:help'>"+Vokabelpaar[0]+"</span></td><td><input id='VokAusgabe"+i+"' type='text'  onkeyup='autofuellen(this.id)' /></td></tr>";	
			Vokabelspeicher[i]=Vokabelpaar[1]
		}
		$id('Vokabeltabelle').innerHTML="<table align='center'>"+Vokabelausgabe.join('')+"</table>";
	}
	else{
		if(Vokabeln.length>0){
			for(i=0;i<Vokabeln.length;i++){
				var Vokabelpaar=Vokabeln[Zufallszahlen[i]].split("QqQqQ");
				Vokabelausgabe[i]="<tr><td class='Vokabelvorgabe' id='VokVorgabe"+i+"' onclick='VokabelHilfe(this.id)'>"+Vokabelpaar[0]+"</td><td><input id='VokAusgabe"+i+"' type='text' onkeyup='autofuellen(this.id)' /></td></tr>";	
				Vokabelspeicher[i]=Vokabelpaar[1]
			}
			$id('Vokabeltabelle').innerHTML="<table align='center'>"+Vokabelausgabe.join('')+"</table>";
		}
		else{
			$id('Vokabeltabelle').innerHTML="<h3 align='center' style='color:red'>Die Übung ist beendet.</h3>Es befinden sich keine Vokabeln mehr im Speicher.";
		}
	}
	$id("Vokabelanzahl").innerHTML="Vokabeln: "+ZuLoesendeVokabeln.length;
	
	$id("ButtonWeiter").style.visibility="hidden";
	$id("ButtonWeiter").style.display="none";
	$id("ButtonWertung").style.visibility="visible";
	$id("ButtonWertung").style.display="block";
}

var VokHilfeSpeicher={};

function autofuellen(id){
	var Nummer=Number(id.replace(/VokAusgabe/,""));
	var Inhalt=Vokabelspeicher[Nummer].split("~");	
	for (var i in Inhalt){
		if($id(id).value.length==10 && Inhalt[i].length>Number($id(id).value.length+5)){	
			if(Inhalt[i].substr(0,$id(id).value.length)== $id(id).value){
				var Abfrage = confirm("Inhalt automatisch vervollständigen?");
				if(Abfrage==true){
					$id(id).value=Inhalt[i];
				}
			}
		}
	}
}

function VokHSpeicherAuf1(){
	for (i in VokHilfeSpeicher){
		VokHilfeSpeicher[i]=1;
	}
}

function blink1(){
	$id('ButtonWeiter').style.color="green";
	blinka=window.setTimeout("blink2()", 1000);
}

function blink2(){
	$id('ButtonWeiter').style.color="black";
	blinkb=window.setTimeout("blink1()", 1000);
}

function blinkstopp(){
	if(typeof(blinka)!="undefined"){window.clearTimeout(blinka);}
	if(typeof(blinkb)!="undefined"){window.clearTimeout(blinkb);}
}

function VokabelHilfe(id){
	var Nummer=id.replace(/VokVorgabe/,"");
	VokHilfeSpeicher[Nummer]=(typeof(VokHilfeSpeicher[Nummer])!="undefined")?VokHilfeSpeicher[Nummer]:1;
	var Mehrfachanzeige=Vokabelspeicher[Nummer].split("~");
	var Ausgabe=[];
		for (i in Mehrfachanzeige){
			//var Semikolon=(i<Mehrfachanzeige.length)?"; ":""
			Ausgabe[i]=Mehrfachanzeige[i].substr(0,VokHilfeSpeicher[Nummer]);//+Semikolon;
		}
	$id("VokAusgabe"+Nummer).value=Ausgabe.join("; ");
	VokHilfeSpeicher[Nummer]++;
}


function TimerzeitSetzen(){
	Zwischenspeicher.Timerzeit=$id("Timer").value;
}

function TimerSetzen(){
	var Sek=$id("Timer").value;

	if(ZuLoesendeVokabeln.length>0){
		if(Sek.search(/\D/)!=-1){
			$id("Timer").value="";
			$id("Timer").blur();
			alert("Bitte nur Zahlen eintragen.");
		}
		else{
			$id("Timer").value=(Sek>0)?Number(Sek)-1:"";
			if($id("Timer").value>0&&Zwischenspeicher.Timer==0){
			Zwischenspeicher.Timeraktiv=1;
			window.setTimeout("TimerSetzen()", 1000);
			}
			else{
				if(Zwischenspeicher.Timerstopp==0&&Sek!=""){
					Zwischenspeicher.Timer=1;
					Wertung();
					Zwischenspeicher.Timerstopp=1;
				}
				else{
					if(Zwischenspeicher.Timerstopp==1){
						$id("Timer").value="";
						$id("Timer").blur();
						alert("Auf \"Neue Übung\" klicken!");
					}
					else{
						Zwischenspeicher.Timer=0;
						$id("Timer").blur();
						alert("Bitte eine Zahl eingeben.");
						
					}
				}
			}
		}
	}
	else{
		if(Zwischenspeicher.Timer==0){
			$id("Timer").value="";
			$id("Timer").blur();
			alert("Auf \"Neue Übung\" klicken!");
		}
		else{
			Zwischenspeicher.Timer=0;
		}
	}
}

function TimerInfo(){
	alert("Nach den eingestellten Sekunden,\nwird die Übung automatisch beendet.")
}

function Wertung(){
	VokHSpeicherAuf1()
	var Gesamtpunktzahl=0;
	var Punkte=0;
	for(i in Vokabelspeicher){
		Gesamtpunktzahl++;	
		var WertIst=$id('Vokabeltabelle').getElementsByTagName('input')[i].value.replace(/^\s{1,}/,'').replace(/\s{1,}$/,'').replace(/\s{1,}/,' ');
		var WertSoll=Vokabelspeicher[i].replace(/^\s{1,}/,'').replace(/\s{1,}$/,'').replace(/\s{1,}/,' ');
		if(WertIst==WertSoll){
			for(j in ZuLoesendeVokabeln){
				if(ZuLoesendeVokabeln[j].replace(/.+QqQqQ/g,"")==WertIst){
				ZuLoesVokA=ZuLoesendeVokabeln.slice(0,j);
				ZuLoesVokE=ZuLoesendeVokabeln.slice((Number(j)+1));
				break;
				}
			}
			ZuLoesendeVokabeln=(typeof(ZuLoesVokA)!="undefined")?ZuLoesVokA.concat(ZuLoesVokE):ZuLoesendeVokabeln;
			$id('Vokabeltabelle').getElementsByTagName('input')[i].style.backgroundColor="#3c0";
			Punkte++;
			AnzeigeRichtig++;
		}
		else{
			if(WertSoll.search(/~/)!=-1){
 				$id('Vokabeltabelle').getElementsByTagName('input')[i].style.backgroundColor="#e30";
				$id('Vokabeltabelle').getElementsByTagName('input')[i].style.textDecoration="line-through";
				var SollArray=WertSoll.split("~");
				for (k in SollArray){
					var WertSollAuswahl=SollArray[k].replace(/^\s{1,}/,'').replace(/\s{1,}$/,'');
					if(WertIst==WertSollAuswahl){
					
						for(l in ZuLoesendeVokabeln){
							var Pruefung=ZuLoesendeVokabeln[l].replace(/.+QqQqQ/g,"").split("~");
							for(m in Pruefung){
								if(Pruefung[m]==WertIst){
								ZuLoesVokA=ZuLoesendeVokabeln.slice(0,l);
								ZuLoesVokE=ZuLoesendeVokabeln.slice((Number(l)+1));
								break;
								}
							}		
						}
						ZuLoesendeVokabeln=(typeof(ZuLoesVokA)!="undefined")?ZuLoesVokA.concat(ZuLoesVokE):ZuLoesendeVokabeln;
						$id('Vokabeltabelle').getElementsByTagName('input')[i].style.backgroundColor="#3c0";
						$id('Vokabeltabelle').getElementsByTagName('input')[i].style.textDecoration="none";	
						Punkte++;	
						AnzeigeRichtig++;
						break;
					}
				}
			}
			else{
				$id('Vokabeltabelle').getElementsByTagName('input')[i].style.backgroundColor="#e30";
				$id('Vokabeltabelle').getElementsByTagName('input')[i].style.textDecoration="line-through";
				
			}
		}
	}
	AnzeigeFalsch=AnzeigeFalsch+Gesamtpunktzahl-Punkte;
	AnzeigeProzRichtig=100/(AnzeigeRichtig+AnzeigeFalsch)*AnzeigeRichtig;
	AnzeigeProzFalsch=100/(AnzeigeRichtig+AnzeigeFalsch)*AnzeigeFalsch;
	
	$id("Anzeige_Proz_richtig").innerHTML="richtig: "+Math.round(AnzeigeProzRichtig)+"%";
	$id("Anzeige_richtig").style.width=Math.round(AnzeigeProzRichtig)+"%";
	$id("Anzeige_richtig").style.backgroundColor="#3c0";
	
	$id("Anzeige_Proz_falsch").innerHTML="falsch: "+Math.round(AnzeigeProzFalsch)+"%";
	$id("Anzeige_falsch").style.width=Math.round(AnzeigeProzFalsch)+"%";
	$id("Anzeige_falsch").style.backgroundColor="#e30";
	
	$id("ButtonWertung").style.visibility="hidden";
	$id("ButtonWertung").style.display="none";

	if(Zwischenspeicher.Timeraktiv==0&&ZuLoesendeVokabeln.length<1){
		$id('Vokabeltabelle').innerHTML="<h3 align='center' style='color:red'>Die Übung ist beendet.</h3>Es befinden sich keine Vokabeln mehr im Speicher.";
		blinkstopp();
	}
	
	if(Zwischenspeicher.Timer==0&&ZuLoesendeVokabeln.length>0){
		$id("ButtonWeiter").style.visibility="visible";
		$id("ButtonWeiter").style.display="block";
	}
	else{
		if(Zwischenspeicher.Timeraktiv==1){
			var Restzeit=$id("Timer").value;
			var AufgabeN=(AnzeigeRichtig!=1)?AnzeigeRichtig+" Aufgaben":"eine Aufgabe";
			$id('Vokabeltabelle').innerHTML="<h3 style='color:green'>Richtig: "+AufgabeN+"</h3><h3 style='color:#30c'>Sekunden: "+(Number(Zwischenspeicher.Timerzeit)-Number(Restzeit))+"</h3>";
			Zwischenspeicher.Timeraktiv=0;
			Zwischenspeicher.Timer=1;
			$id("Timer").value="";
			blinkstopp();
		}
	}
}